using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace ProgressStatusBar
{
	/// <summary>
	/// Summary description for UserControl1.
	/// </summary>
	public class ProgressStatusBar : System.Windows.Forms.StatusBar
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ProgressStatusBar()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call
			this.SizingGrip = false;
			this.ShowPanels = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// ProgressStatusBar
			// 
			this.Name = "ProgressStatusBar";

		}
		#endregion


        	
			protected override void	OnDrawItem(StatusBarDrawItemEventArgs e)
			{
				if	(e.Panel.GetType().ToString().EndsWith("ProgressPanel"))
				{
					ProgressPanel ProgressPanel =	(ProgressPanel) e.Panel;

					if (ProgressPanel.Value >ProgressPanel.Minimum)
					{
						int NewWidth =
							(int)(((double)ProgressPanel.Value / (double)ProgressPanel.Maximum) *
							(double)ProgressPanel.Width);
						Rectangle NewBounds = e.Bounds;
						SolidBrush PaintBrush = new SolidBrush(ProgressPanel.ForeColor);
						NewBounds.Width = NewWidth;
	
						e.Graphics.FillRegion(PaintBrush, new Region(NewBounds));
						PaintBrush.Dispose();
					}
					else
					{
						base.OnDrawItem(e);
					}
				}
				else
				{
					base.OnDrawItem(e);
				}
			}

			public void UpdateValue(ProgressPanel ProgressPanel, int	NewValue)
			{
				ProgressPanel.Value = NewValue;
			}
		}

		public class ProgressPanel : System.Windows.Forms.StatusBarPanel
		{
			private int m_Minimum = 1;
			private int m_Maximum = 100;
			private int m_Value = 0;
			private Color m_Color;

			public ProgressPanel()
			{
				this.Style = StatusBarPanelStyle.OwnerDraw;
				this.ForeColor = Color.DarkBlue;
			}

			public int Minimum
			{
				get { return m_Minimum; }
				set     { m_Minimum = value; }
			}

			public int Maximum
			{
				get { return m_Maximum; }
				set     { m_Maximum = value; }
			}
        	
			public int Value
			{
				get { return m_Value; }
				set { m_Value = value; }
			}

			public Color ForeColor
			{
				get     { return m_Color; }
				set { m_Color = value; }
			}
		}

	}

